/**
 * @typedef {import('./Build').Build & { pluginName: string }} PluginBuild
 */
/**
 * Enrich the esbuild build with a transformation pipeline and emit methods.
 * @param {import('esbuild').Plugin} pluginInstance The esbuild plugin instance.
 * @param {import('esbuild').PluginBuild} pluginBuild The esbuild build.
 */
export function useRna(pluginInstance: import('esbuild').Plugin, pluginBuild: import('esbuild').PluginBuild): import("./Build.js").Build;
/**
* @returns {import('esbuild').Plugin}
*/
export function rnaPlugin(): import('esbuild').Plugin;
export * from "./Build.js";
export * from "./helpers.js";
export type PluginBuild = import('./Build').Build & {
    pluginName: string;
};
